# Demonstration of piff failing with PixelGrid size 25.

import pickle
import logging

import galsim
import piff
import matplotlib.pyplot as plt

stars = pickle.load(open("stars.pickle", "rb"))

piffConfig = {
    'type': "Simple",
    'model': {
        'type': 'PixelGrid',
        'scale': 1.0,
        # NOTE: Change this to 21 or 23 to see a successful result.
        'size': 25
    },
    'interp': {
        'type': 'BasisPolynomial',
        'order': 1
    },
    'outliers': {
        'type': 'Chisq',
        'nsigma': 4,
        'max_remove': 0.05
    }
}

piffResult = piff.PSF.process(piffConfig)
# Run on a single CCD, and in image coords rather than sky coords.
wcs = {0: galsim.PixelScale(1.0)}
pointing = None
logging.basicConfig()
logger = logging.getLogger('PIFF')
logger.setLevel('DEBUG')
piffResult.fit(stars, wcs, pointing, logger)

plt.imshow(piffResult.draw(10, 10).array)
plt.show()
